﻿using igGrid.Mapper.Models;
using Infragistics.Web.Mvc;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace igGrid.Mapper.Controllers
{
    public class HomeController : Controller
    {
        [GridDataSourceAction]
        public ActionResult Index()
        {
            var data = GetCustomersData().AsQueryable();
            return View(data);
        }

        public List<Customer> GetCustomersData()
        {
            string[] Customers = { "Paul Henriot", "Karin Josephs", "Mario Pontes", "Mary Saveley" };
            string[] Countries = { "France", "Germany", "Brazil", "Belgium" };
            string[] PostalCodes = { "75008 ", "10115 ", "13010", "1299" };
            string[] PhoneNumbers = { "(+33) 23 67 22 20", "(+49) 23 67 22 20", "(+55) 23 67 22 20", "(+32) 23 67 22 20" };

            List<Customer> CustomersList = new List<Customer> { };
            for (int i = 0; i < Customers.Length; i++)
            {
                CustomersList.Add(new Customer
                {
                    CustomerID = i,
                    Name = Customers[i],
                    contact = new Contact {
                            id = i, city = "City " + i, 
                            postCode = "1234" + i,
                            country = new Country { Name = Countries[i], Code = PostalCodes[i]},
                            geo = new System.Device.Location.GeoCoordinate { Altitude = 320, Latitude = 90, Longitude = 90}
                    }
                });
            }
            return CustomersList;
        }

        [HttpGet]
        [ActionName("countries")]
        public ActionResult CountryList()
        {
            // my live implementation
            //return Json(dbContext.Countries.AsQueryable(), JsonRequestBehavior.AllowGet);

            // example

            string[] Countries = { "France", "Germany", "Brazil", "Belgium" };
            string[] PostalCodes = { "75008 ", "10115 ", "13010", "1299" };
            List<Country> countryList = new List<Country> { };
            for (int i = 0; i < Countries.Length; i++)
            {
                countryList.Add(
                    new Country {Name = Countries[i], Code = PostalCodes[i] }
                    );
            }
            return Json(countryList.AsQueryable(), JsonRequestBehavior.AllowGet);
        }

    }
}